commit 813cf5d170843dac18124c07e7746068c6f22a00
Author: Richard Sandiford <richard.sandiford@arm.com>
Date:   Fri Oct 21 10:06:13 2022 +0100

    aarch64: Fix matching of BRKNS
    
    Unlike other flag-setting SVE instructions, BRKNS sets the flags
    based on an all-true governing predicate, rather than the GP operand.
    
    gcc/
            * config/aarch64/iterators.md (SVE_BRKP): New iterator.
            * config/aarch64/aarch64-sve.md (*aarch64_brkn_cc): New pattern.
            (*aarch64_brkn_ptest): Likewise.
            (*aarch64_brk<brk_op>_cc): Restrict to SVE_BRKP.
            (*aarch64_brk<brk_op>_ptest): Likewise.
    
    gcc/testsuite/
            * gcc.target/aarch64/sve/acle/general/brkn_1.c: Expect separate
            PTEST instructions.
            * gcc.target/aarch64/sve/acle/general/brkn_2.c: New test.
    
    (cherry picked from commit 6bec66640597e2604f51fc1642c7d279164cd442)

diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/general/brkn_1.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/general/brkn_1.c
index 7fd9318c13f..c548810f169 100644
--- a/gcc/testsuite/gcc.target/aarch64/sve/acle/general/brkn_1.c
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/general/brkn_1.c
@@ -18,5 +18,6 @@ test2 (svbool_t pg, svbool_t x, svbool_t y, int *any)
   return svptest_any (pg, res);
 }
 
-/* { dg-final { scan-assembler-times {\tbrkns\t} 2 } } */
-/* { dg-final { scan-assembler-not {\tbrkn\t} } } */
+/* { dg-final { scan-assembler-times {\tbrkn\t} 2 } } */
+/* { dg-final { scan-assembler-times {\tptest\t} 2 } } */
+/* { dg-final { scan-assembler-not {\tbrkns\t} } } */
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/general/brkn_2.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/general/brkn_2.c
new file mode 100644
index 00000000000..74b6927410a
--- /dev/null
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/general/brkn_2.c
@@ -0,0 +1,23 @@
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+#include <arm_sve.h>
+
+void
+test1 (svbool_t pg, svbool_t x, svbool_t y, int *any, svbool_t *ptr)
+{
+  svbool_t res = svbrkn_z (pg, x, y);
+  *any = svptest_any (svptrue_b8 (), res);
+  *ptr = res;
+}
+
+int
+test2 (svbool_t pg, svbool_t x, svbool_t y, int *any)
+{
+  svbool_t res = svbrkn_z (pg, x, y);
+  return svptest_any (svptrue_b8 (), res);
+}
+
+/* { dg-final { scan-assembler-times {\tbrkns\t} 2 } } */
+/* { dg-final { scan-assembler-not {\tbrkn\t} } } */
+/* { dg-final { scan-assembler-not {\tptest\t} } } */

